	;
	; The main driver that holds everything together.
	;
TEST_MODE=0

	ORG $1001-2
	DW $1001
	
	DW $100B,0
	DB $9E,"4109",0,0,0
	
ptr_chr	= $D0
ptr_col	= $D2
circle_sin_ptr	= $D4
color_sin_ptr	= $D5
circle_line	= $D6

plink_pos	= $0800+7*40+19
	
start	SEI
	;
	if TEST_MODE=1
	JSR test_start
	else
	STA $FF3F
	endif
	;             
	JMP demo_start
	;
	include "!player.asm"
	include "common1.asm"
	;
	include "gfxback.asm"
	include "digi_drum.asm"
digi_end
	;                    
	include "player_init.asm"
	include "music.asm"
	include "common2.asm"
	;
	include "plink.asm"
	;
plink_color_data
	include "plink_color_data_hex_mod.asm"
	;
	include "legion.asm"
	include "plasma.asm"
	include "squares.asm"
	include "notes2.asm"
	;	
plink_charmap
	include "plink_charmap.asm"

m_shift = 40+28
makes_charmap
	include "makes_charmap.asm"
	
free_start
	if TEST_MODE=1
	DB $AA        
	endif
	
	;ALIGN 256
	ORG $3600
	include "data_plasma_sinus.asm"
	
	ORG $3800
plink_charset
	include "plink_charset.asm"
	
	include "data_circles_charset.asm"
	
	include "makes_charset.asm"
	
	include "data_one_square.asm"
	
	include "data_notes2.asm"
	;
	ORG $3F00
	include "data_plasma_chars.asm"
final_end
	if TEST_MODE=1
	DB $AA        
	;
	; only for testing!
	include "test.asm"
	;
	endif
