	;
	; Common set of routines.
	; These will be wiped out by the last part,
	; that uses the graphics screen. 
	;

	;
	; ---
	; A,X : pointer
	; Y   : colors
	;
fullscreen_fade
	STA ptr
	STX ptr+1
	;
init_fade
	JSR sync_bottom
	LDA (ptr),y
	STA $FF19
	;
	LDA $FF1D
if_1	CMP $FF1D
	BEQ if_1
	;
	DEY
	BPL init_fade
	;
	RTS
	
special_clear
	LDY #$11
spclr	STA $080B,y
	STA $080B+40,y
	STA $080B+80,y
	STA $0B7A,y
	STA $0B7A+40,y
	STA $0B7A+80,y
	DEY
	BPL spclr
	RTS
	;           
special_clear2
	LDY #$07
spclr2	STA $3800,y
	DEY
	BPL spclr2
	RTS
	;
	;
	;
fade_text
	;JMP *
	LDX fade_text_flash_count
	BNE no_fade_text_init
	;
	LDA fade_text_count
	ASL a
	CLC
	ADC fade_text_count
	TAY
	;
	LDA (fade_text_positions),y	; low byte
	STA fade_text_ptr
	INY
	LDA (fade_text_positions),y	; high byte
	STA fade_text_ptr+1
	INY
	LDA (fade_text_positions),y	; use next low byte to get word length
	STA fade_text_width
	;
no_fade_text_init
	LDA fade_text_ptr
	STA fade_text_ptr2 
	LDA fade_text_ptr+1
	STA fade_text_ptr2+1
	BEQ skip_fade
	;
fade_text_colors_ptr
	LDA $0800,x		; self-mod
	STA fade_text_color+1
	;
	LDX #$02		; height (3 chars tall)
ft_2
	LDY fade_text_width 
fade_text_color
	LDA #$77
ft_1
	STA (fade_text_ptr2),y
	DEY
	BPL ft_1
	;
	LDA fade_text_ptr2
	CLC
	ADC #40
	STA fade_text_ptr2
	BCC *+4
	INC fade_text_ptr2+1
	;
	DEX
	BPL ft_2
	;              
	; ---
	;                   
skip_fade
	LDX fade_text_flash_count
	LDY fade_text_count
	;
	INX                        
	CPX #48			; fixed width
	BNE no_fade_text_wrap
	;
	INY
	LDX #$00
no_fade_text_wrap
	;
	STY fade_text_count
	STX fade_text_flash_count
	;
	RTS