	;
	; The "hidden" greetings part.
	; It will only show if the SHIFT key is held down,
	; otherwise this part is skipped.
	;
	; It contains the greetings,
	; also greetings to everyone I forgot! :-)
	;
STANDALONE=0

	if STANDALONE=1
	ORG $1001-2
	DW  $1001
	DW $100B,0
	DB $9E,"4109",0,0,0
	endif
	
txt_ptr	= $C0
dest	= $C2

greets_start
	;---  
	SEI            
	;
	if STANDALONE=1
	;
	LDA #$00
	STA $23
	;
	STA $FF3E
	JSR $FF4F
	DB "PRESS SHIFT...      ",0
	endif
	;
	STA $FF3F
	;
	LDA #$FD
	STA $FD30
	STA $FF08
	LDA $FF08
	AND #$80	; Query keyboard for "shift"
	BEQ pressed
	;
	JMP $100D
	;
pressed
	;    
	;----
;	LDX #Channel1 & 255
;	LDY #Channel1 >> 8
;	JSR set_ch1
;	;
;	LDX #Channel2 & 255
;	LDY #Channel2 >> 8
;	JSR set_ch2
	;
	JSR PLAYER_FREQ_INIT
	;----
	;
	LDY #$00
	JSR sync_bottom
	;
	STY $FF19
	STY $FF15
	STY $FF06       
	STY $FF12
	STY dest
	LDA #$38
	STA $FF13
	;
	LDA #$71
	LDY #$08
	JSR fill3
	;
	LDA #$00
	LDY #$0C
	STY dest+1
	JSR fill3
	;      
	LDA #text_data & 255
	STA txt_ptr
	LDA #text_data >> 8 
	STA txt_ptr+1
	;
	;
c1	LDA chars,Y
	STA $3800,Y
	LDA chars+$100,Y
	STA $3900,Y
	LDA chars+$200,Y
	STA $3A00,Y
	DEY
	BNE c1
	;
	;lda chars
	;
	JSR sync_bottom
	;
	LDA #$1B
	STA $FF06
	;
loop	JSR sync_cc
	;
call_fade
	BIT fade
	;
	JSR PLAYER
	;
	; ---
	;       
	;DEC $FF19
c11	LDY #$00
	LDX #$27
c10	LDA colors,y
	STA $0800+40*00,x
	STA $0800+40*01,x
	;STA $0800+40*02,x
	INY
	LDA colors,y
	STA $0800+40*03,x
	STA $0800+40*04,x
	INY
	LDA colors,y
	STA $0800+40*05,x
	STA $0800+40*06,x
	INY
	LDA colors,y
	STA $0800+40*07,x
	STA $0800+40*08,x
	INY
	LDA colors,y
	STA $0800+40*09,x
	STA $0800+40*10,x
	INY
	LDA colors,y
	STA $0800+40*11,x
	STA $0800+40*12,x
	INY
	LDA colors,y
	STA $0800+40*13,x
	STA $0800+40*14,x
	INY
	LDA colors,y
	STA $0800+40*15,x
	STA $0800+40*16,x
	INY
	LDA colors,y
	STA $0800+40*17,x
	STA $0800+40*18,x
	INY
	LDA colors,y
	STA $0800+40*19,x
	STA $0800+40*20,x
	INY
	LDA colors,y
	STA $0800+40*21,x
	STA $0800+40*22,x
	INY
	LDA colors,y
	STA $0800+40*23,x
	STA $0800+40*24,x
	TYA
	SEC
	SBC #10
	TAY
	DEX
	BMI c12
	JMP c10
c12
	;INC $FF19
	;
	LDA colors+$7F-8	; wait until last color has faded to black
	BNE c50          
	;    
	STA $FF11		; sound off
	STA $FF06		; screen off
	;
	JMP $100D		; go!
	;
	; ---
c50	LDA c11+1
	SEC
	SBC #$01
	AND #$3F
	STA c11+1
	;
	; ----
	; write letters
	;              
	;
c40	LDA #$00
	CLC
	ADC #$01
	AND #$01
	STA c40+1
	BNE c3
	;
	LDY #$00
	LDA (txt_ptr),y
	BPL c41
	;
	JMP loop_end
	;
c41	LDY #$00
	LDA #$40
	STA (dest),y
	LDA #$41
	LDY #$28
	STA (dest),y
	JMP loop_end
	;
c3	LDY #$00
	LDA (txt_ptr),y
	BPL c2 
	;
	CMP #$FD
	BNE not_skip 
	;
	JSR txt_ptr_inc
	;
	LDA #80
	JSR dest_add
	JMP c3
	;           
not_skip
	CMP #$FE
	BNE text_not_over
	;
	LDA #$20
	STA call_fade
	JMP loop_end
	;                
text_not_over
	JSR txt_ptr_inc
	;
	LDA #40
	JSR dest_add
	JMP c3
	;
c2	STA (dest),y
	CLC
	ADC #$20
	LDY #$28
	STA (dest),y
	;
	JSR txt_ptr_inc
	;      
	LDA #$01
	JSR dest_add
	;           
loop_end
	JMP loop    
	
dest_add
	CLC
	ADC dest
	STA dest
	BCC *+4
	INC dest+1   
	RTS
	
fade
c32	LDA #$5E	; delay
	BEQ c30
	INC c32+1
	RTS
	;
c30	LDA #$00
	CLC     
	ADC #$04
	AND #$7F
	STA c30+1
	TAX
	;  
	LDY #$03
c21	LDA colors,x
	SEC
	SBC #$10
	BPL c20
	LDA #$00
c20	STA colors,x
	INX
	DEY
	BPL c21
c31	RTS
	
txt_ptr_inc
	LDA txt_ptr
	CLC
	ADC #$01
	STA txt_ptr
	BCC *+4
	INC txt_ptr+1
	RTS
	
all_over
	RTS
	
	include "gplayer.asm"
	include "player_init.asm"
	include "gmusic.asm"
	include "common1.asm"
	
	align 256
colors
	DB $32,$42,$52,$62,$62,$62,$62,$62
	DB $62,$62,$62,$62,$62,$52,$42,$32
	;
	DB $3B,$4B,$5B,$6B,$6B,$6B,$6B,$6B
	DB $6B,$6B,$6B,$6B,$6B,$5B,$4B,$3B
	;
	DB $34,$44,$54,$64,$64,$64,$64,$64
	DB $64,$64,$64,$64,$64,$54,$44,$34
	;
	DB $3B,$4B,$5B,$6B,$6B,$6B,$6B,$6B
	DB $6B,$6B,$6B,$6B,$6B,$5B,$4B,$3B
	;
	; ---
	;    
	DB $32,$42,$52,$62,$62,$62,$62,$62
	DB $62,$62,$62,$62,$62,$52,$42,$32
	;
	DB $3B,$4B,$5B,$6B,$6B,$6B,$6B,$6B
	DB $6B,$6B,$6B,$6B,$6B,$5B,$4B,$3B
	;
	DB $34,$44,$54,$64,$64,$64,$64,$64
	DB $64,$64,$64,$64,$64,$54,$44,$34
	;
	DB $3B,$4B,$5B,$6B,$6B,$6B,$6B,$6B
	DB $6B,$6B,$6B,$6B,$6B,$5B,$4B,$3B
	
text_data
	CMAP " ",0
	CMAP "a",1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26
	CMAP "7",27
	CMAP "U",28
	CMAP "*",29
	CMAP "W",30
	CMAP "M",31
	;     
	;   0123456789_123456789_123456789_123456789
	DB "greetings to                            ",$FD
	DB "tomM of lod * gaia * tlc * lavina * luca",$FF
	DB "svs * ati * ninja * sld * dr death * mMc",$FF
	DB "jimMy * fred * harry * mMaugli * mMurphy",$FF
	DB "bubis * beast * sensor * optika * nukemM",$FF
	DB "dcd * bsz * abcug * proky * gotu * larry",$FF
	DB "skoro * mMmMs * kichy * siz * hifi * tlt",$FF
	DB "csio * lacoste * wWls * nightbird * tcfs",$FF
	DB "rachy * unreal * crowWn * pigmMy * erich",$FF
	DB "pzsolt * litwWr * coyote * lando * chris",$FF    
	DB "ulysses777 * rUdiger * sidius * jamMes c",$FF
	DB "mMike d * bszggg * bushrat * fatmMan    ",$FE

	;ORG $3800
chars		; 256*16 h
	DB $00,$00,$00,$00,$00,$00,$00,$00
	DB $00,$00,$00,$00,$7C,$C6,$06,$7E
	DB $C0,$C0,$C0,$C0,$FC,$C6,$C6,$C6
	DB $00,$00,$00,$00,$7C,$C6,$C0,$C0
	DB $06,$06,$06,$06,$7E,$C6,$C6,$C6
	DB $00,$00,$00,$00,$7C,$C6,$C6,$FE
	DB $3C,$66,$60,$60,$F8,$60,$60,$60
	DB $00,$00,$00,$00,$7E,$C6,$C6,$C6
	DB $C0,$C0,$C0,$C0,$DC,$E6,$C6,$C6
	DB $00,$18,$18,$00,$38,$18,$18,$18
	DB $00,$0C,$0C,$00,$1E,$0C,$0C,$0C
	DB $C0,$C0,$C0,$C0,$C6,$CC,$D8,$F0
	DB $38,$18,$18,$18,$18,$18,$18,$18
	DB $00,$00,$00,$00,$EF,$71,$61,$61
	DB $00,$00,$00,$00,$DC,$E6,$C6,$C6
	DB $00,$00,$00,$00,$7C,$C6,$C6,$C6
	DB $00,$00,$00,$00,$FC,$C6,$C6,$C6
	DB $00,$00,$00,$00,$7E,$C6,$C6,$C6
	DB $00,$00,$00,$00,$EC,$76,$60,$60
	DB $00,$00,$00,$00,$7C,$C6,$C0,$7C
	DB $60,$60,$60,$60,$F8,$60,$60,$60
	DB $00,$00,$00,$00,$C6,$C6,$C6,$C6
	DB $00,$00,$00,$00,$C6,$C6,$C6,$C6
	DB $00,$00,$00,$00,$E1,$61,$61,$61
	DB $00,$00,$00,$00,$C6,$C6,$6C,$38
	DB $00,$00,$00,$00,$C6,$C6,$C6,$C6
	DB $00,$00,$00,$00,$FE,$06,$0C,$38
	DB $FE,$C6,$06,$06,$0C,$18,$18,$18
	DB $00,$C6,$C6,$00,$C6,$C6,$C6,$C6
	DB $00,$00,$00,$00,$38,$7C,$FE,$FE
	DB $00,$00,$00,$00,$86,$86,$86,$86
	DB $00,$00,$00,$00,$3C,$C6,$86,$86

	DB $00,$00,$00,$00,$00,$00,$00,$00
	DB $C6,$CE,$76,$00,$00,$00,$00,$00
	DB $C6,$E6,$DC,$00,$00,$00,$00,$00
	DB $C0,$C6,$7C,$00,$00,$00,$00,$00
	DB $C6,$CE,$76,$00,$00,$00,$00,$00
	DB $C0,$C0,$7C,$00,$00,$00,$00,$00
	DB $60,$60,$60,$00,$00,$00,$00,$00
	DB $C6,$C6,$7E,$06,$06,$C6,$7C,$00
	DB $C6,$C6,$C6,$00,$00,$00,$00,$00
	DB $18,$18,$7E,$00,$00,$00,$00,$00
	DB $0C,$0C,$0C,$0C,$0C,$CC,$78,$00
	DB $D8,$CC,$C6,$00,$00,$00,$00,$00
	DB $18,$18,$3C,$00,$00,$00,$00,$00
	DB $61,$61,$61,$00,$00,$00,$00,$00
	DB $C6,$C6,$C6,$00,$00,$00,$00,$00
	DB $C6,$C6,$7C,$00,$00,$00,$00,$00
	DB $C6,$E6,$DC,$C0,$C0,$C0,$C0,$00
	DB $C6,$CE,$76,$06,$06,$06,$06,$06
	DB $60,$60,$60,$00,$00,$00,$00,$00
	DB $06,$C6,$7C,$00,$00,$00,$00,$00
	DB $60,$66,$3C,$00,$00,$00,$00,$00
	DB $C6,$CE,$76,$00,$00,$00,$00,$00
	DB $6C,$38,$10,$00,$00,$00,$00,$00
	DB $61,$61,$3F,$00,$00,$00,$00,$00
	DB $6C,$C6,$C6,$00,$00,$00,$00,$00
	DB $C6,$CE,$76,$06,$06,$C6,$7C,$00
	DB $60,$C0,$FE,$00,$00,$00,$00,$00
	DB $18,$18,$18,$00,$00,$00,$00,$00
	DB $C6,$CE,$76,$00,$00,$00,$00,$00
	DB $FE,$7C,$38,$00,$00,$00,$00,$00
	DB $86,$86,$FC,$00,$00,$00,$00,$00
	DB $86,$86,$86,$00,$00,$00,$00,$00

	DB $00,$FE,$FE,$FE,$FE,$FE,$FE,$FE
	DB $FE,$FE,$FE,$FE,$FE,$FE,$FE,$00
	