	;
	; The "LEGION" part.
	;
	; I originally envisioned this quite differently,
	; but this is what came out... It's okay as an "intro effect".
	;
STANDALONE=0
IDEBUG=0

	if STANDALONE=1 
	ORG $1001-2
	DW $1001
	
	DW $100B,0
	DB $9E,"4109",0,0,0
	endif
	
ptr_chr	= $D0
ptr_col	= $D2
circle_sin_ptr	= $D4
color_sin_ptr	= $D5
circle_line	= $D6

;legion_text_count	= $DE
;legion_text_flash_count	= $DF
;legion_text_width	= $E0
;legion_text_ptr		= $E2
;legion_text_ptr2	= $E4

plink_pos	= $0863+3*40
	
legion_start
	SEI
	;
	if STANDALONE=1
	JMP ls1

	include "!player.asm"
	include "player_init.asm"
	include "music.asm"
	include "common1.asm"
	include "common2.asm"
	;
ls1	STA $FF3F		; --- only if compiled standalone
	;
	LDA $FF07
	AND #$40 
	ORA #$84
	STA $FF07
	;
	LDA #$00		; set font
	STA $FF12
	STA $FF15		; bg & border
	;
	STA $23
	;
	LDA #$38
	STA $FF13
	;
	LDX #Channel1_Circle & 255	; init music
	LDY #Channel1_Circle >> 8
	JSR set_ch1
	;
	LDX #Channel2_Circle & 255
	LDY #Channel2_Circle >> 8
	JSR set_ch2
	;
	JSR PLAYER_FREQ_INIT
	;
	endif
	;
;	LDY #$08	; clear screen ($0800-08FF)
;	LDA #$00
;	TAX
;	JSR fill
;	LDY #$0B	; clear screen ($0B00-0BFF)
;	TAX
;	JSR fill
	;
	JSR sync_bottom	; border to black
	LDA #$00
	STA $FF19
	;
	STA fade_text_count
	STA fade_text_flash_count
	STA circle_sin_ptr
	STA color_sin_ptr
	;
	JSR special_clear
	JSR special_clear2	
	;
;	LDX #$07
;	LDA #$00
;lf_1	STA $3800,x
;	DEX
;	BPL lf_1
	;
	;LDA #29		; (space char), clear screen
	LDY #$0D
	LDX #$01		; clear middle of screen
	JSR fill
	;
	JSR shutdown_check
	;   
makes_width = $12
makes_pos = $0C0B
tedgo_width = $12
tedgo_pos = $0F7A
	;
	LDX #makes_width-1		; copy text onto screen (not visible, black on black)
mkcopy1	LDA makes_charmap,x
	STA makes_pos,x
	LDA makes_charmap+164,x
	STA makes_pos+40,x
	LDA #$44
	STA makes_pos+80,x
	;
	LDA makes_charmap+17+164*0,x
	STA tedgo_pos,x
	LDA makes_charmap+17+164*1,x
	STA tedgo_pos+40,x
	LDA makes_charmap+17+164*2,x
	STA tedgo_pos+80,x
	DEX
	BPL mkcopy1
	;
	LDA #legion_text_positions & 255
	STA fade_text_positions
	LDA #legion_text_positions >> 8
	STA fade_text_positions + 1
	;
	LDA #legion_text_colors & 255
	STA fade_text_colors_ptr+1
	LDA #legion_text_colors >> 8 
	STA fade_text_colors_ptr+2
	;        
	; ---
	;
	LDX #irq_legion1 & 255
	LDY #irq_legion2 >> 8
	LDA #$10
	JSR set_irq
	;
	JMP *		; main program: infinite loop
	
legion_control
	LDY fade_text_count
	LDX fade_text_flash_count
	BNE leg3
	;
	CPY #$03
	BNE leg1
	;              
	LDA #$FF		; Start the legion effect
	BNE set_legion
	;
leg1    CPY #$04
	BNE leg2
	;                       
	LDA #$01		; Make legion effect go backwards
	BNE set_legion
	;
leg2	CPY #$05
	BNE leg3
	;  
	LDA #$01		; start slanted effect
	STA circle_sin_add+1
	LDA #$FF
	STA color_sin_add+1
	;
	LDA #$65		; ADC $00 opcode
	BNE set_slant
	;
leg3	CPY #$07		; backwards
	BNE leg4
	CPX #$20
	BNE leg4
	;          
	LDA #$E5		; SBC $00 opcode
set_slant
	STA slant
	STA slant+2
	STA slant+4             
	;
	RTS
	;
leg4
	CPY #$0B		; stop effect
	BNE leg5
	CPX #$16
	BNE leg5a
	;
	;--- 
	LDX #$5F
	LDA #$41
leg5_1	STA color_sinus,x	; set colors to $41 (for plink)
	DEX
	BPL leg5_1
	;---
	;LDX #$0A		; set chars to "space"
	LDX #16*4		; set chars to "space"
	LDA #28
leg5_2	STA circle_sinus,x
	;STA circle_chars-1,x
	DEX
	BNE leg5_2
	;
	TXA			; A=0, add zero = no movement
	STA $3800+28*8+7,x	; clear first char, it was one pixel
set_legion
	STA circle_sin_add+1
	STA color_sin_add+1
	RTS      
	;
leg5a	CPX #$1F
	BNE leg5
	;
	LDA #$4C		; start earlier
 	STA irq_legion2_pos+1
	;
	RTS
	;
leg5	CPY #$0C
	BNE leg6
	;
legion_end
	if STANDALONE=1
	JMP $FFF6
	else
	;     
	if IDEBUG=1
	INC $FF19
	endif
	JSR copy_plink1
	if IDEBUG=1
	DEC $FF19
	endif
	;
	LDX #$1F
	LDA #$FF
leg5_3	STA $3800+28*8,x	; fill circle chars
	DEX
	BPL leg5_3
	;
	LDA #$2C
	STA plink_2
	;
	JMP plink_start
	endif
	;	
leg6	RTS
	
	if STANDALONE=1
	ALIGN 256
	endif
	
irq_legion1
	INC $FF09
	if IDEBUG=1
	INC $FF19
	endif
	JSR PLAYER
	if IDEBUG=1
	DEC $FF19
	endif
	;
irq_legion2_pos
	LDX #$8B
	LDA #irq_legion2 & 255
	;  
irq_legion_set
	STX $FF0B
	STA $FFFE
	;
	RTI
	;
irq_legion2
	INC $FF09
	if IDEBUG=1
	INC $FF19
	endif
	JSR PLAYER_SOUND
	;
	JSR space_check
	;
;	LDA fade_text_count
;	CMP #$0C ;#legion_text_widths_end - legion_text_widths - 1
;	;LDA $58		; CH1
;	;CMP #$AD
;	BEQ legion_end
	;               
	JSR fade_text
	JSR legion_control
	;
;draw_legion
	LDA #$19		; legion screen position: $0919
	STA ptr_chr
	STA ptr_col
	LDA #$09
	STA ptr_col+1
	ORA #$04
	STA ptr_chr+1 
	;
	LDA #$04		; loop from 4 to 0 = line counter for 5 lines
	STA circle_line  
	;
circle_line_loop
	LDA circle_sin_ptr
	CLC
	ADC #circle_sinus & 255
	;
slant	BIT circle_line		; self-mod, will become ADC and SBC
	BIT circle_line		; for "slanted" effect
	BIT circle_line
	;
	STA cir_sin1+1
	;
	LDA color_sin_ptr
	;AND #$7F		; max out at 64
	CLC                   
	ADC #color_sinus & 255
	;
	;ADC #5
	;SBC circle_line 
	;
	STA col_sin1+1
	;
	LDX circle_line
	LDA legion_mul,x
	CLC  
	ADC #legion_logo_data & 255
	STA dc1+1
	;
	LDX #$00
dc1	LDA legion_logo_data,x
	BMI skip
	;BEQ skip_circle
	;
	;CMP #$01
	;BEQ skip_space
	;
	;CMP #$03
	;BEQ next_line
	;
col_sin1
	LDA color_sinus,x
	STA new_circle_color+1
	;
cir_sin1
	LDA circle_sinus,x
	;LDY circle_sinus,x
	;LDA circle_chars,y
	;
	; --- draw one circle
	;
	LDY #$00
	STA (ptr_chr),y	; draw 4 chars in 2x2 area
	CLC
	ADC #$01
	INY
	STA (ptr_chr),y
	LDY #$28	; next line
	;CLC
	ADC #$01
	STA (ptr_chr),y
	;CLC
	ADC #$01
	INY
	STA (ptr_chr),y
	;
new_circle_color
	LDA #$00
	STA (ptr_col),y	; set the color in a 2x2 area
	DEY            
	STA (ptr_col),y
	LDY #$01
	STA (ptr_col),y
	DEY            
	STA (ptr_col),y    
	; 
;skip_circle
	LDA #$02	; two characters (one circle)
	DB $2C
skip
	AND #$7F
;next_line
;	LDA #43		; go to next line (43 chars)
;	DB $2C
;skip_space
;	LDA #$01	; one character (space)
	;
	; ---
	;
	CLC		; add A to 16 bit cursor position value
	ADC ptr_col
	STA ptr_col
	STA ptr_chr
	;
	LDA ptr_col+1
	ADC #$00
	STA ptr_col+1
	ORA #$04	; adjust high byte to point to color map
	STA ptr_chr+1
	;
	INX
	CPX #22
	BNE dc1
	;
	DEC circle_line
	BMI circle_line_loop_end
	JMP circle_line_loop
	;                       
circle_line_loop_end
	LDA circle_sin_ptr
	CLC
circle_sin_add
	ADC #$00
	BMI csp_wrap
	CMP #32
	BNE csp_no_wrap
	LDA #$00
	DB $2C
csp_wrap
	LDA #31
csp_no_wrap
	STA circle_sin_ptr
	;
	LDA color_sin_ptr
	CLC          
color_sin_add
	ADC #$00
	BMI csp_wrap2
	CMP #64
	BNE csp_no_wrap2
	LDA #$00
	DB $2C
csp_wrap2
	LDA #63
csp_no_wrap2
	STA color_sin_ptr
	;
;	RTS
	;
	if IDEBUG=1
	DEC $FF19
	endif
	;  
	LDX #$10
	LDA #irq_legion1 & 255
	JMP irq_legion_set
	
;legion_fade_text
;	LDY legion_text_flash_count
;	BNE no_legion_text_init
;	;
;	LDX legion_text_count
;	;
;	LDA legion_text_widths,x
;	STA legion_text_width
;	;
;	TXA
;	ASL a
;	TAX
;	;
;	LDA legion_text_positions,x
;	STA legion_text_ptr
;	LDA legion_text_positions+1,x
;	;AND #$0B
;	STA legion_text_ptr+1
;	;
;no_legion_text_init
;	LDA legion_text_ptr
;	STA legion_text_ptr2 
;	LDA legion_text_ptr+1
;	STA legion_text_ptr2+1
;	;
;	LDA legion_text_colors,y
;	STA legion_text_color+1
;	;
;	LDX #$03	; height
;lft_2
;	LDY legion_text_width 
;legion_text_color
;	LDA #$77
;lft_1
;	STA (legion_text_ptr2),y
;	DEY
;	BPL lft_1
;	;
;	LDA legion_text_ptr2
;	CLC
;	ADC #40
;	STA legion_text_ptr2
;	BCC *+4
;	INC legion_text_ptr2+1
;	;
;	DEX
;	BPL lft_2
;	;              
;	; ---
;	; 
;	LDX legion_text_flash_count
;	LDY legion_text_count
;	;
;	INX                        
;	CPX #legion_text_colors_end - legion_text_colors
;	BNE no_legion_text_wrap
;	;
;	INY
;	LDX #$00
;no_legion_text_wrap
;	;

legion_text_positions
	DW makes_pos   -$0400	; -$0400 is needed to point to color memory instead of character memory
	DB 4
	DW makes_pos+6 -$0400	; top 3 words
	DB 4
	DW makes_pos+11-$0400
	DB 4
	DW $0000		; does nothing, pause
	DB 0
	DW $0000
	DB 0
	DW $0000
	DB 0
	DW $0000
	DB 0
	DW $0000
	DB 0
	DW tedgo_pos   -$0400	; bottom 4 words
	DB 5
	DW tedgo_pos+7 -$0400
	DB 2
	DW tedgo_pos+11-$0400
	DB 3
	DW tedgo_pos+16-$0400
	DB 1
	DW $0000
	DB 0

	if STANDALONE=1
	ALIGN 256
	endif                                           

	; must be before the table
	; when it's slanted like this: \
	; the code will read bytes from before the table
	DB 28+00*4,28+00*4,28+00*4,28+01*4,28+01*4,28+02*4,28+03*4,28+04*4
	DB 28+05*4,28+06*4,28+07*4,28+08*4,28+08*4,28+09*4,28+09*4,28+09*4
	DB 28+09*4,28+09*4,28+09*4,28+08*4,28+08*4,28+07*4,28+06*4,28+05*4
	DB 28+04*4,28+03*4,28+02*4,28+01*4,28+01*4,28+00*4,28+00*4,28+00*4
circle_sinus
	DB 28+00*4,28+00*4,28+00*4,28+01*4,28+01*4,28+02*4,28+03*4,28+04*4
	DB 28+05*4,28+06*4,28+07*4,28+08*4,28+08*4,28+09*4,28+09*4,28+09*4
	DB 28+09*4,28+09*4,28+09*4,28+08*4,28+08*4,28+07*4,28+06*4,28+05*4
	DB 28+04*4,28+03*4,28+02*4,28+01*4,28+01*4,28+00*4,28+00*4,28+00*4
	;
	DB 28+00*4,28+00*4,28+00*4,28+01*4,28+01*4,28+02*4,28+03*4,28+04*4
	DB 28+05*4,28+06*4,28+07*4,28+08*4,28+08*4,28+09*4,28+09*4,28+09*4
	DB 28+09*4,28+09*4,28+09*4,28+08*4,28+08*4,28+07*4,28+06*4,28+05*4
	DB 28+04*4,28+03*4,28+02*4,28+01*4,28+01*4,28+00*4,28+00*4,28+00*4
	;
	; ***
	;    
	if STANDALONE=1
	ALIGN 256
	endif
	;
color_sinus
	DB 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
	DB 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
	;
	DB $09,$09,$19,$12, $12,$22,$22,$32, $32,$42,$42,$52, $52,$62,$62,$72
	DB $62,$62,$52,$52, $42,$42,$32,$32, $22,$22,$12,$12, $19,$09,$09,$00
	;
	DB 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
	DB 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
	;
legion_text_colors
	DB $07,$00,$07,$07,$07	; from dark yellow to light yellow then white
	DB $17,$07,$17,$17,$17	; length is adjusted to match tempo of music
	DB $27,$17,$27,$27,$27
	DB $37,$27,$37,$37,$37
	DB $47,$37,$47,$47,$47
	DB $57,$47,$57,$57,$57
	DB $67,$57,$67,$67,$67
	DB $77,$67,$77,$77,$77
	DB $71,$71,$71,$71,$71,$71,$71,$71
legion_text_colors_end

legion_mul
	DB 22*4,22*3,22*2,22*1,22*0

;circle_chars
;	DB 28,32,36,40, 44,48,52,56, 60,64
	;
	if STANDALONE=1
	ALIGN 256
	endif
	;
legion_logo_data
	DB $02,$82,$82, $81, $02,$02,$02, $81, $02,$02,$02, $81, $02, $81, $02,$02,$02, $81, $02,$02,$02, $AB
	DB $02,$82,$82, $81, $02,$82,$82, $81, $02,$82,$82, $81, $02, $81, $02,$82,$02, $81, $02,$82,$02, $AB
	DB $02,$82,$82, $81, $02,$02,$82, $81, $02,$82,$02, $81, $02, $81, $02,$82,$02, $81, $02,$82,$02, $AB
	DB $02,$82,$82, $81, $02,$82,$82, $81, $02,$82,$02, $81, $02, $81, $02,$82,$02, $81, $02,$82,$02, $AB
	DB $02,$02,$02, $81, $02,$02,$02, $81, $02,$02,$02, $81, $02, $81, $02,$02,$02, $81, $02,$82,$02, $AB
	;
	
;color_sinus
;	DB 0,1,2,3,4,5,6,7,6,5,4,3,2,1
;	DB 0,1,2,3,4,5,6,7,6,5,4,3,2,1
;	DB 0,1,2,3,4,5,6,7,6,5,4,3,2,1
;	DB 0,1,2,3,4,5,6,7,6,5,4,3,2,1
;	DB 0,1,2,3,4,5,6,7,6,5,4,3,2,1
	;
	if STANDALONE=1
	
	ORG $3800
plink_charset
	include "plink_charset.asm"
	
circles ; 160*16 h
	DB $00,$00,$00,$00,$00,$00,$00,$01
	DB $00,$00,$00,$00,$00,$00,$00,$00
	DB $00,$00,$00,$00,$00,$00,$00,$00
	DB $00,$00,$00,$00,$00,$00,$00,$00
	DB $00,$00,$00,$00,$00,$00,$01,$03
	DB $00,$00,$00,$00,$00,$00,$00,$80
	DB $01,$00,$00,$00,$00,$00,$00,$00
	DB $00,$00,$00,$00,$00,$00,$00,$00
	DB $00,$00,$00,$00,$00,$03,$07,$07
	DB $00,$00,$00,$00,$00,$80,$C0,$C0
	DB $07,$03,$00,$00,$00,$00,$00,$00
	DB $C0,$80,$00,$00,$00,$00,$00,$00
	DB $00,$00,$00,$00,$03,$07,$0F,$0F
	DB $00,$00,$00,$00,$80,$C0,$E0,$E0
	DB $0F,$07,$03,$00,$00,$00,$00,$00
	DB $E0,$C0,$80,$00,$00,$00,$00,$00
	DB $00,$00,$00,$03,$0F,$0F,$1F,$1F
	DB $00,$00,$00,$80,$E0,$E0,$F0,$F0
	DB $1F,$0F,$0F,$03,$00,$00,$00,$00
	DB $F0,$E0,$E0,$80,$00,$00,$00,$00

	DB $00,$00,$07,$0F,$1F,$3F,$3F,$3F
	DB $00,$00,$C0,$E0,$F0,$F8,$F8,$F8
	DB $3F,$3F,$1F,$0F,$07,$00,$00,$00
	DB $F8,$F8,$F0,$E0,$C0,$00,$00,$00
	DB $00,$07,$1F,$3F,$3F,$7F,$7F,$7F
	DB $00,$C0,$F0,$F8,$F8,$FC,$FC,$FC
	DB $7F,$7F,$3F,$3F,$1F,$07,$00,$00
	DB $FC,$FC,$F8,$F8,$F0,$C0,$00,$00
	DB $07,$1F,$3F,$7F,$7F,$FF,$FF,$FF
	DB $C0,$F0,$F8,$FC,$FC,$FE,$FE,$FE
	DB $FF,$FF,$7F,$7F,$3F,$1F,$07,$00
	DB $FE,$FE,$FC,$FC,$F8,$F0,$C0,$00
	DB $1F,$3F,$7F,$FF,$FF,$FF,$FF,$FF
	DB $F0,$F8,$FC,$FE,$FE,$FE,$FE,$FE
	DB $FF,$FF,$FF,$FF,$7F,$3F,$1F,$00
	DB $FE,$FE,$FE,$FE,$FC,$F8,$F0,$00
	DB $7F,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	DB $FC,$FE,$FE,$FE,$FE,$FE,$FE,$FE
	DB $FF,$FF,$FF,$FF,$FF,$FF,$7F,$00
	DB $FE,$FE,$FE,$FE,$FE,$FE,$FC,$00
	
	include "makes_charset.asm"
	
one_square	; 24*24 h
	DB $00,$00,$00,$00,$00,$FF,$80,$80
	DB $00,$00,$00,$00,$00,$FF,$00,$00
	DB $00,$00,$00,$00,$00,$F8,$08,$08

	DB $80,$80,$80,$80,$80,$80,$80,$80
	DB $00,$00,$00,$00,$00,$00,$00,$00
	DB $08,$08,$08,$08,$08,$08,$08,$08

	DB $80,$FF,$00,$00,$00,$00,$00,$00
	DB $00,$FF,$00,$00,$00,$00,$00,$00
	DB $08,$F8,$00,$00,$00,$00,$00,$00

	
plink_charmap
	include "plink_charmap.asm"
m_shift = 40+28
makes_charmap
	include "makes_charmap.asm"
	
	endif
	