	;
	; The notes part.
	;
	; This part went through a lot of changes until
	; it became the current form. The routine is very
	; fast and efficient, but not flexible.
	; (It would not work with a different sinus table.)
	;
STANDALONE=0
DEBUG=0

	if STANDALONE=1
	ORG $1001-2
	DW  $1001
	
	DW $100B,0
	DB $9E,"4109",0,0,0
	endif
	
notes_ptr	= $D0
scrl	= $D2
store	= $D3
notec	= $D4
source1	= $D6
source2	= $D8
newchar_dest	= $DA

charset	= $3800
notes_sin2	= $2200		; just overwrite previous code
notes_sin3	= $2300
;mul8_lo	= charset + $400
;mul8_hi	= charset + $500

notes_pos	= $0D17
	
notes2_start
	if STANDALONE=1
	JSR $FF4F
	DB $93
	DB 0
	JMP ns1
	;
	include "common1.asm"
	include "common2.asm"
	;    
ns1	SEI
	STA $FF3F
	;
	LDA #$00
	STA $FF12           
	;
	LDX #Channel1_notes & 255	; init music
	LDY #Channel1_notes >> 8
	JSR set_ch1
	;
	LDX #Channel2_notes & 255
	LDY #Channel2_notes >> 8
	JSR set_ch2
	;
	JSR PLAYER_FREQ_INIT
	endif
	;
	JSR shutdown_check 
	;         
	JSR play_only		; turns off screen
	;
	LDA $FF07		; make part ntsc compatible...
	AND #$40		; see, all it took was this few lines of code!
	ORA #$80
	STA notes_ntsc1+1
	STA notes_ntsc2+1
	;
	; --- clear screen
	;       
	LDA #$06		; color: darkest blue
	STA $FF15		; also pre-set background color
	LDY #$08		; from $0800
	JSR fill3
	;   
	LDA #$02		; $02 is space character
	;LDY #$0C
	LDX #$03
	JSR fillc
	;       
	TYA
	LDY #charset >> 8	; clear charset
	if STANDALONE=1
	STY $FF13
	endif
	LDX #$00
	JSR fill
	;
	STY scrl
	;                
	; --- make 8 versions of the "sprite"
	;
	; @ab 0
	; cde 1
	; fgh 2
	; ijk 3
	; lmn 4
	; opq 5
	; rst 6
	; uvw 7
	;
	;LDY #$00
nc2	JSR copy_note
	;
	TYA
	CLC
	ADC #$09
	TAY
	CPY #$C0
	BCC nc2
	;
	LDY #$C0 + $01			; cde + opq
	JSR copy_note
	LDY #$C0 + 8+8-3
	JSR copy_note
	;
	LDY #$C0 + $04 + 4*8		; lmn + fgh
	JSR copy_note
	LDY #$C0 + 8+2 + 4*8
	JSR copy_note
	;
	; --- convert notes_sin1 table
	;                  
	INX				; X=0
sl1	LDA notes_sin1,x
	LSR a
	LSR a
	LSR a 
	TAY
	LDA mul40,y
	CLC
	ADC #notes_pos & 255		; add low byte of screen pos
	STA notes_sin2,x
	;
	LDA notes_sin1,x
	AND #$07
	STA plus1+1
	ASL a   
	CLC
plus1	ADC #$00
	STA notes_sin3,x
	INX
	BNE sl1
	;
;	LDX #$00
;	STX mul8_lo
;	LDA #charset >> 8
;	STA mul8_hi
;	;
;il1	LDA mul8_lo,x
;	CLC
;	ADC #$08
;	STA mul8_lo+1,x
;	LDA mul8_hi,x
;	ADC #$00
;	STA mul8_hi+1,x
;	;
;	INX
;	CPX #$FF
;	BNE il1        
	;               
mking_width = $1B
mking_pos = $0C06
mking_beg = 99
mxing_width = $26
mxing_pos = $0F71
mxing_beg = 126
	;
	LDX #mking_width-1
mkcopy3	LDA makes_charmap+mking_beg+164*0,x
	STA mking_pos,x
	LDA makes_charmap+mking_beg+164*1,x
	STA mking_pos+40,x
	LDA makes_charmap+mking_beg+164*2,x
	STA mking_pos+80,x
	DEX
	BPL mkcopy3
	;          
	LDX #mxing_width-1
mkcopy4	LDA makes_charmap+mxing_beg+164*0,x
	STA mxing_pos,x
	LDA makes_charmap+mxing_beg+164*1,x
	STA mxing_pos+40,x
	LDA makes_charmap+mxing_beg+164*2,x
	STA mxing_pos+80,x
	DEX
	BPL mkcopy4
	;
	; ---------
	;                         
	INX	; X=0
	STX fade_text_flash_count
	STX fade_text_count
	;
	LDA #notes_text_positions & 255
	STA fade_text_positions
	LDA #notes_text_positions >> 8
	STA fade_text_positions + 1
	;
	LDA #notes_text_colors & 255
	STA fade_text_colors_ptr+1
	LDA #notes_text_colors >> 8 
	STA fade_text_colors_ptr+2
	;
	; ---------
	;
	JSR sync_cc	; screen on
	;
	LDA #$1B
	STA $FF06    
	;
	LDX #notes_irq_1 & 255
	LDY #notes_irq_1 >> 8
	LDA #$21
	JSR set_irq
	;
notes2_loop
	LDA #$7c
	JSR sync_any
	;
	if DEBUG=1
	DEC $FF15
	endif
	JSR do_notes
	if DEBUG=1
	INC $FF19
	endif
	;
	JMP notes2_loop
	;
	; ----------------------------------
	;
notes_irq_1
	STA save_a
	STX save_x
	STY save_y
	;
	LDX #$71
	;
	LDY #$A8
	CPY $FF1E
	BCS *-3
	;
	STX $FF19
	STX $FF15
	;
	LDX #$46
	;
	LDA #$22
	CMP $FF1D
	BNE *-3
	;
	CPY $FF1E
	BCS *-3
	;
	STX $FF19
	STX $FF15
	;
scrl_set
	LDA #$00
notes_ntsc1
	ORA #$00
	STA $FF07
	;
	;DEC $FF19
	JSR PLAYER
	;INC $FF19
	;
	JSR fade_text
	;
	LDA #$AB
	LDX #notes_irq_2 & 255
	BNE notes_irq_set
	;
notes_irq_2
	STA save_a
	STX save_x
	STY save_y
	;
	NOP
	NOP
	;        
	LDX #$71
	;
	LDY #$A8
	CPY $FF1E
	BCS *-3
	;
	STX $FF19
	STX $FF15
	;
	LDX #$06
	;
	LDA #$AD
	CMP $FF1D
	BNE *-3
	;
	CPY $FF1E
	BCS *-3
	;
	STX $FF19
	STX $FF15
	;
notes_ntsc2
	LDA #$88
	STA $FF07
	;
	JSR PLAYER_SOUND
	JSR space_check
	;                     
	LDA #$21
	LDX #notes_irq_1 & 255
	;
notes_irq_set
	STA $FF0B
	STX $FFFE
	;
	LDA save_a
	LDX save_x
	LDY save_y
	;
	INC $FF09
	;
	RTI
	;     
	; ---------
	;
;nsync0	LDA #$13
;	JSR sync_any
;	;
;	LDA #$7C
;	JSR sync_any
;	;    
;	if DEBUG=1
;	DEC $FF19 
;	endif
;	;
;	JSR fade_text
;	;
;	LDA #$88
;	STA $FF07
	;
	; -- clear whole area
	;
do_notes
	LDA scrl
	STA scrl_set+1
	;
	LDX #40*4-1
	LDA #$02
cl2	STA notes_pos,x
	STA notes_pos+4*40,x
	DEX
	BNE cl2
	;
start_x1
	LDX #$00
note_loop
	LDY #notes_pos >> 8	; high byte of position of effect
	STY notes_ptr+1
	;  
	TXA
	CLC
sin_notes_ptr
	ADC #$00
	TAY
	;  
	TXA
	CLC
	ADC notes_sin2,y
	;
	;ADC #$17		; low byte of position of effect
	STA notes_ptr
	BCC *+4
	INC notes_ptr+1
	;        
	LDA notes_sin3,y	; draw one note
	LDY #0
	STA (notes_ptr),y	; top char
	;
	LDY #40
	CLC
	ADC #$01
	STA (notes_ptr),y	; 2nd char one line below
	;
	LDY #80
	;CLC
	ADC #$01
	STA (notes_ptr),y	; 3rd char two lines below
	;  
	INX
note_count
	CPX #$01		; length (or number of notes), self-mod
	BNE note_loop
	;
	; ---       
	;
start_x2
	LDX #$00
note2_loop
	LDY #notes_pos >> 8	; high byte of screen position
	STY notes_ptr+1
	;
	TXA
	CLC
	ADC #sin_wavelength >>1	; shift sinus pointer
sin2_notes_ptr
	ADC #$00
	TAY
	;
	TXA
	CLC
	ADC notes_sin2,y
	;ADC #$17		; low byte of screen pos
	STA notes_ptr
	BCC *+4
	INC notes_ptr+1
	;        
	LDA notes_sin3,y
	STA store
	CMP #$15
	BEQ put1_skip
	;
	;---
	LDY #0			; top char
	LDA (notes_ptr),y	; get current char from screen
	TAY
	LDA or_lookup,y
	BNE put1
	LDA store
put1	LDY #0
	STA (notes_ptr),y
	;
put1_skip
	;
	INC store
	;   
	;---
	LDY #40			; 2nd char
	LDA (notes_ptr),y	; get current char from screen
	TAY
	LDA or_lookup,y
	BNE put2
	LDA store
put2	LDY #40
	STA (notes_ptr),y
	;
	INC store
	;   
	;---
	LDY #80			; 3rd char
	LDA (notes_ptr),y	; get current char from screen
	TAY
	LDA or_lookup,y
	BNE put3
	LDA store
put3	LDY #80
	STA (notes_ptr),y
	;  
	INX
note2_count
	CPX #$01		; length (or number of notes), self-mod
	BNE note2_loop
	;                
	; ---       
	;
	LDA sinc+1
	CLC
	ADC #$01
	CMP #48			; wrap at 48 (which matches the music's tempo)
	BNE sinc1
	LDA #$00
sinc1	STA sinc+1
	;
sinc	LDY #$00
	LDA scroll_add,y
	CLC
	ADC scrl
	CMP #$08
	BCS swrap

	;LDY scrl		; keep scrolling screen
	;INY
	;CPY #$08
	;BEQ swrap
	;
	STA scrl
	;
	LDA sin_notes_ptr+1     
	CLC
	ADC #$01
	CMP #sin_wavelength
	BNE *+4
	LDA #$00
	STA sin_notes_ptr+1
	;
	;
	LDA sin2_notes_ptr+1     
	CLC
	ADC #$01
	CMP #sin_wavelength
	BNE *+4
	LDA #$00
	STA sin2_notes_ptr+1
	;
	JMP s_nowrap2
	;	
swrap	;
	;LDY #$00
	AND #$07
	STA scrl
	;
	LDA note_count+1
	CMP #$29
	BEQ s_nowrap1
	INC note_count+1
	JMP s_nowrap2
s_nowrap1
	;
	LDA note2_count+1
	CMP #$29
	BEQ s_nowrap3
	INC note2_count+1
	JMP s_nowrap2
s_nowrap3
	LDA start_x1+1
	CMP #$28
	BEQ s_nowrap4
	INC start_x1+1
	JMP s_nowrap2
s_nowrap4
	LDA start_x2+1
	CMP #$28
	BEQ notes_end
	INC start_x2+1
	;
s_nowrap2
	;            
	if DEBUG=1
	INC $FF19 
	endif
	;
	RTS
	;
notes_end
	if STANDALONE=1
	JMP $FFF6
	else
	JMP gfxback_start
	endif
	
copy_note
	LDX #$0F
nc3	LDA charset,y
	ORA one_note,x
	STA charset,y
	INY
	DEX
	BPL nc3
	RTS
	
notes_text_positions
	DW mking_pos   -$0400	; -$0400 is needed to point to color memory instead of character memory
	DB 6
	DW mking_pos+07-$0400
	DB 4
	DW mking_pos+12-$0400
	DB 1
	DW mking_pos+14-$0400
	DB 2
	DW mking_pos+17-$0400
	DB 4
	DW mking_pos+22-$0400
	DB 4
	DW mxing_pos   -$0400	; bottom words
	DB 3
	DW mxing_pos+04-$0400
	DB 3
	DW mxing_pos+08-$0400
	DB 8
	DW mxing_pos+17-$0400
	DB 3
	DW mxing_pos+21-$0400
	DB 3
	DW mxing_pos+24-$0400
	DB 6
	DW mxing_pos+31-$0400
	DB 1
	DW mxing_pos+34-$0400
	DB 3
	DW $0000
	DB 0
	DW $0000
	DB 0
	
notes_text_colors
	DB $16,$16,$16,$26,$16
	DB $26,$26,$26,$36,$26
	DB $36,$36,$36,$46,$36
	DB $46,$46,$46,$56,$46
	DB $56,$56,$56,$66,$56
	DB $66,$66,$66,$76,$66
	DB $76,$76,$76,$71,$76
	DB $71,$71,$71,$71,$71
	DB $71,$71,$71,$71,$71,$71,$71,$71
notes_text_colors_end
	
scroll_add
;32,1
	DB $06,$05,$05,$04,$03,$04,$03,$03,$03,$03,$02,$03,$02,$02,$02,$02
	DB $01,$02,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
	DB $00,$01,$01,$01,$01,$00,$01,$01,$01,$00,$01,$01,$00,$01,$01,$01
	
	if STANDALONE=1     
	include "!player.asm"
	include "player_init.asm"
	include "music.asm"
	;
	ORG $3600
makes_charmap
	include "makes_charmap.asm"
	
	
	ORG $3800
	include "plink_charset.asm"
	include "circles_charset.asm"
	include "makes_charset.asm"
	;
	include "data_notes2.asm"
	endif
