	;
	; this driver simulates how the demopart will poll the music
	; all 4 calls are made at the same time
	; and the TED sounds registers are set later
	;

	;ORG $0580-2
	;DW $0580
	ORG $1580-2
	DW $1580
 	include "!playerv.asm"
	include "!player.asm"
	include "music.asm"
	include "volmap.asm"
	
	;ORG $1001
	;DW $100B,0
	;DB $9E,"4109",0,0,0

	ORG $2000
	JMP $3000

start2
	SEI
	;
	LDA #$41
	STA $FF19
	LDA #$51
	STA $FF15
	;                   
	JSR PLAYER_FREQ_INIT
	;
	; ---
	;        
	LDY #$00
	LDX #$00
delay	INX
	BNE delay
	INY
	BNE delay
	;       
sync0	LDA $FF1D
	CMP #$20
	BNE sync0
	LDA $FF1c
	CMP #$FF
	BNE sync0
	;
	SEI  
	DEC $FF19
	JSR PLAYER
	JSR PLAYER_SOUND
	JSR PLAYER_SOUND
	JSR PLAYER_SOUND
	INC $FF19
	CLI
	;
vol_down
	LDA #$00
	BEQ no_vol_down
	;
vol_delay
	LDA #$00
	CLC
	ADC #$01
	AND #$0F
	STA vol_delay+1
	BNE no_vol_down
	;
	LDA VOLUME
	CLC
	ADC #$09
	CMP #21*9
	BNE do_vol_down
	JMP $FFF6
do_vol_down
	STA VOLUME
no_vol_down
	;
	; ---
	;
kdelay	LDY #$00
	BEQ kcheck
	DEY 
	JMP kend
	
kcheck	LDA #$BF
	STA $FD30
	STA $FF08
	LDA $FF08
	CMP #$F7
	BNE x5
	;   
	LDA #$21
	STA $FF15
	STA vol_down+1
	; do something on keypress
	;
x5	;
	LDY #$04    
kend	STY kdelay+1
	;
	JMP sync0
	
	;
	; ##########################
	;

	ORG $3000 
	;        
	SEI
	STA $FF3F
	LDX #irq & 255
	LDY #irq >> 8
	STX $FFFE	
	STY $FFFF
	;
	LDA #$A2
	STA $FF0A 
	;
	LDA #$00
	STA $11
	STA $12
	;        
	LDA #$00
	STA $FF00
	LDA #$07
	STA $FF01
	;
	JMP start2
	;  
irq
	PHA
	TXA
	PHA  
	;
	DEC $FF19
	;  
	LDX #$00
	LDA $FF1D
	CMP #$50
	BCC bp
	;
	LDX #$05
	LDA $FF1D
	CMP #$A0
	BCC bp
	;
	LDX #10
	LDA $FF1D
	CMP #$F0
	BCC bp 
	;
	LDX #15
bp            
	STX $FF15
	LDA $C9,x
	STA $FF11
	LDA $C6,x
	STA $FF0E
	LDA $C7,x
	STA $FF0F
	LDA $C8,x
	STA $FF10
	LDA $FF12
	AND #$FC
	ORA $CA,x
	STA $FF12
	;
	INC $FF19
	;
	INC $FF0B
	INC $FF0B
	INC $FF0B
	INC $FF0B
	;
	INC $FF09
	;
	PLA 
	TAX
	PLA
	RTI
	