	;
	; The last part of Plink.
	;
STANDALONE=0
IDEBUG=0
            
	if STANDALONE=1            
 	ORG $1001-2
	DW $1001       
	endif

eor_flag = $1C
digi_bass	= $1F00

; with screen off	
;		;=$065 ;101 =C 2
;init_speed	= $0E6 ;230 =C 1
;		;=$1E2 ;482 =C 0
;bass_speed	= $3E2 ;    =C-1
             
; with screen on             
		;=$065
init_speed	=$70; $0D0
		;=$1CE
bass_speed	= $3C8

frame_count	= $06*2
	
current_speed	= $D4	; 16 bit
frame		= $D6	; 8 bit
	
	if STANDALONE=1
	DW $100B,0
	DB $9E,"4109",0,0,0
	endif
	
	if STANDALONE=1
	SEI
	STA $FF3F   
	;
	LDY #$00
	LDX #$00
delay1	INX
	BNE delay1
	INY
	BNE delay1
	;
	LDA #$00
	STA $23	; shutdown
	;
	JMP gfxback_start
	endif
	
digi_start
	;
	LDX #Channel1_digi & 255
	LDY #Channel1_digi >> 8
	JSR set_ch1
	;
	LDX #Channel2_digi & 255
	LDY #Channel2_digi >> 8
	JSR set_ch2
	;
	if STANDALONE=1
	JSR PLAYER_FREQ_INIT
	endif
	;
	JSR PLAYER_INIT
	;
	LDA #$50
	STA $FF19
	;
	LDX #$00		; make up square waveform
il1	TXA
	AND #$08		; every 8th byte
	LSR A			; clears carry
	ADC #$32
	STA digi_bass,x
	INX
	BNE il1
	;        
;	LDX #$0F
;il0a	LDA digi_bass_init,x
;	STA digi_bass,x
;	STA digi_bass+$10,x
;	DEX
;	BPL il0a
;	;
;	LDX #$1F
;il1	LDA digi_bass,x
;	STA digi_bass+$20,x
;	STA digi_bass+$40,x
;	STA digi_bass+$60,x
;	STA digi_bass+$80,x
;	STA digi_bass+$A0,x
;	STA digi_bass+$C0,x
;	STA digi_bass+$E0,x		
;	DEX
;	BPL il1  
	;        
	LDA #init_speed & 255
	STA current_speed
	STA $FF00
	LDA #init_speed >> 8 
	STA current_speed+1
	STA $FF01 
	;
	LDA #frame_count+1
	STA frame
	;
	LDA #$A8
	STA $FF0A
	;
	;LSR $FF06	; turn screen off
	;
	LDX #digi_irq_end - digi_irq
irq_copy
	LDA digi_irq,x
	STA $10,x
	DEX
	BPL irq_copy
	;
	LDA #$10
	STA $FFFE
	LDA #$00
	STA $FFFF
	;
	LDA #$24
	STA eor_flag
	;
;	LDA #$FE
;	STA $FF0F
;	STA $FF0E
;	LDA #$03
;	STA $FF10
;	LDA $FF12
;	ORA #$03
;	STA $FF12
	;
	;LDA #$38
	;STA $FF11
	;
	LDA #$2C
	STA setvol	; disable player from setting $FF11
	;
	CLI    
	;        
digi_loop
	LDA #$16
	CMP $FF1D
	BCS digi_loop
	;
	if IDEBUG=1
	INC $FF19  
	endif
	JSR PLAYER
	if IDEBUG=1
	DEC $FF19  
	endif        
	;
	JSR draw_background
	;
dsync1
	LDA #$64
	CMP $FF1D
	BCS dsync1
	;
	if IDEBUG=1
	INC $FF19  
	endif
	JSR PLAYER_SOUND
	;
	JSR write_next_letter
	CPX #$FF
	BNE not_over
	;
	LDA #$20		; JSR opcode
	STA call_digi_voldown	; set it, start calling volume down routine
not_over
	;
	if IDEBUG=1
	DEC $FF19  
	endif
	;
dsync2
	LDA #$B2     
	CMP $FF1D
	BCS dsync2
	;
	if IDEBUG=1
	INC $FF19  
	endif
	JSR PLAYER_SOUND
	;
call_digi_voldown
	BIT digi_voldown
	;
	if IDEBUG=1
	DEC $FF19  
	endif
	;
dsync3
	LDA #$FE
	CMP $FF1D
	BNE dsync3
	;
	if IDEBUG=1
	INC $FF19  
	endif
	;
	JSR PLAYER_SOUND
	;
	LDA digi_bass+$FF
	CMP #$30
	BEQ all_over
	;
	DEC frame
	BNE no_frame_wrap
	;
	LDA #frame_count
	STA frame
	;
	LDX #init_speed & 255
	LDY #init_speed >> 8 
	;
	LDA eor_flag
	EOR #$D0 ^ $24
	;
	SEI    
	;
	STA eor_flag
	BPL set_speed 
	;
	LDX #bass_speed & 255
	LDY #bass_speed >> 8
	;
set_speed
	STX current_speed
	STY current_speed+1
	;
	CLI
	;                
no_frame_wrap
	if IDEBUG=1
	DEC $FF19  
	endif
	;
	;JMP *  
	;
sync2	LDA $FF1D
	CMP #$10
	BCS sync2
	;
	JMP digi_loop
	
all_over
	SEI    
	JSR sync_bottom
	;
	LDA #$00
	STA $FF19
	STA $FF15
	STA $FF11
	STA $FF06
	LDY #$05	; from $500
	LDX #$0A	; 8 + 3 pages (all the way to $0FFF)
	JSR fill
	;
	LDA #$A2	; clean up
	STA $FF0A
	LDA #$C4
	STA $FF12
	LDA #$D1
	STA $FF13
	;
	LDA $FF07
	AND #$40
	ORA #$08
	STA $FF07
	;
	JMP $0200
	
digi_voldown
	LDY #$01
dvx	LDX #$00
dv1	LDA digi_bass,x
	CMP #$30		; if value is already at $30 (quiet)
	BEQ no_dec		; don't decrement it any further
	SEC
	SBC #$01		; minus 1
no_dec	STA digi_bass,x
	INX
	DEY
	BPL dv1
	STX dvx+1
	;
	LDA digi_bass+$08
	CMP #$33
	BNE dv2
	;
	LDA #$04		; speed out rest of volume down
	STA digi_voldown+1
	;
dv2	RTS
		
digi_irq
	PHA
	;
digi_ptr
	LDA digi_bass
	STA $FF11
	INC digi_ptr-digi_irq+$10+1
	;
	LSR $FF09
	BNE no_wrap
	;
	LDA current_speed
	CLC
	ADC #$02
	STA current_speed
	BCC *+4
	INC current_speed+1	
	;
no_wrap	LDA current_speed
	STA $FF00
	LDA current_speed+1
	STA $FF01
	;
	PLA
	;
	RTI
digi_irq_end

;digi_bass_init
;dvol=$32
;	DB dvol+4,dvol+4,dvol+4,dvol+4,dvol+4,dvol+4,dvol+4,dvol+4
;	DB dvol+0,dvol+0,dvol+0,dvol+0,dvol+0,dvol+0,dvol+0,dvol+0
	     
	if STANDALONE=1
	include "gfxback.asm"
	include "!player.asm"
	include "player_init.asm"
	include "common1.asm"
	ALIGN 256
	NOP
	NOP
	endif
	include "digimus.asm"
arpeggio = arp37
	;
	;include "music.asm"
	