	;
	; The "PLINK" part.
	;
	; just displays and flashes the text.
	; 
demo_start
	JSR sync_cc
	;
	LDA $FF07
	AND #$40
	BEQ pal
	;
	LDX #$F7
	STX last_line_value+1
	;
pal	ORA #$84
	STA $FF07           
	;
	LDA #$00
	STA $FF15
	STA $FF12
	STA $23		; should be sta shutdown, but the compiler screws it up
	;
	LDX #Channel1 & 255
	LDY #Channel1 >> 8
	JSR set_ch1
	;
	LDX #Channel2 & 255
	LDY #Channel2 >> 8
	JSR set_ch2
	;
	JSR PLAYER_FREQ_INIT
	;
	JSR screen_off
	;  
	LDA #init_fade_colors & 255
	LDX #init_fade_colors >> 8
	LDY #init_fade_colors_end-init_fade_colors-1
	JSR fullscreen_fade
	;
	LDA #plink_charset >> 8
	STA $FF13
	;
	LDA #$41	; gray color for inverted chars, same as border color
	LDY #$08
	JSR fill3
	;
	TYA		; A=$00, space char
	LDX #$03
	JSR fillc	; clear screen
	;
	JSR copy_plink1
	;   
	LDA #$43
	JSR sync_any
	;
plink_start        
	; re-init values
	JSR shutdown_check
	;
	LDA #$FF
	STA plink_color_counter+1
	LDA #23
	STA plink_flash_count+1
	;
	LDA #$41	; gray color for inverted chars, same as border color
	JSR special_clear                                             
	;
	LDX #irq2 & 255
	LDY #irq2 >> 8
	LDA #$B0
	JSR set_irq
	;
	JSR sync_bottom
	;
	LDA #$41
	STA $FF19
	;
	LDA #$1B
	STA $FF06
	;
	JSR copy_plink2	
	;
	; ---	
	;
	LDA #$FF	; full chars
	JSR special_clear2
	;
	LDA #$00		; erase leftover from LEGION part
	LDY #$61
cl1a	STA $0C0B,y
	STA $0F7A,y
	DEY
	BPL cl1a
	;
	; --- 
	;
	JMP *
	;    
	
cpptr1	= $A0
cpptr2	= $A2	
	
copy_plink1               
	;
	LDA #$04
	STA plink_pos+$03C8+16
	LDA #$0C
	STA plink_pos+$03C8+17
	;      
	; 31c7
	LDA #plink_charmap & 255
	STA cpptr1
	LDA #plink_charmap >> 8
	STA cpptr1+1
	;
	LDA #(plink_pos+$03C8+40*1) & 255
	STA cpptr2
	LDA #(plink_pos+$03C8+40*1) >> 8
	STA cpptr2+1
	;
	LDX #$05
	DB $2C
copy_plink2
	LDX #$04
	;
cpl0	LDY #32
cpl1	LDA (cpptr1),y
	STA (cpptr2),y
;	LDA plink_charmap,y		; draw "plink" onto screen
;	STA plink_pos+$03C8+40*1,y
;	;
;	LDA plink_charmap+33*1,y
;	STA plink_pos+$03C8+40*2,y
;	;
;	LDA plink_charmap+33*2,y
;	STA plink_pos+$03C8+40*3,y
;	;
;	LDA plink_charmap+33*3,y
;	STA plink_pos+$03C8+40*4,y
;	;
;	LDA plink_charmap+33*4,y
;	STA plink_pos+$03C8+40*5,y
;	;
;	LDA plink_charmap+33*5,y
;	STA plink_pos+$03C8+40*6,y
	;
	DEY    
	;
	BPL cpl1
	;
	LDA cpptr1
	CLC
	ADC #33
	STA cpptr1
	BCC *+4
	INC cpptr1+1
	;
	LDA cpptr2
	CLC
	ADC #40
	STA cpptr2
	BCC *+4
	INC cpptr2+1
	;
	DEX
	BPL cpl0
	;
	RTS
	
init_fade_colors
	DB $41,$31,$41,$31,$31,$21
	DB $31,$21,$21,$11,$21,$11
	DB $11,$01,$11,$01,$01,$00
	DB $01,$00	; 20
init_fade_colors_end

plink_colors
	DB $2,$2,$B,$B
	DB $4,$4,$6,$6
plink_flash
	DB $70,$70,$60,$70,$60,$60
	DB $50,$50,$40,$50,$40,$40
	DB $30,$30,$20,$30,$20,$20
	DB $10,$10,$00,$10,$00,$00
	
irq1	INC $FF09
	;
	STA $20
	STX $21
	STY $22
	;
	;DEC $FF19
	JSR PLAYER
	;INC $FF19
	;
	LDA #$B0
	LDX #irq2 & 255
	BNE plink_irq_end
	;
irq2	INC $FF09
	;
	STA $20
	STX $21
	STY $22
	;
	;DEC $FF19
	JSR PLAYER_SOUND
	;
	JSR space_check
	;
plink_flash_count
	LDX #23			; self-mod
	INX
	CPX #24
	BNE no_plink_flash_wrap
	;
plink_color_counter
	LDY #$FF		; self-mod
	INY
	CPY #$08
	BEQ plink_done
	STY plink_color_counter+1
	LDA plink_colors,y
	STA plink_color_or_value+1
	;
	LDX #$00
no_plink_flash_wrap
	STX plink_flash_count+1
	LDA plink_flash,x       
plink_color_or_value
	ORA #$07
	STA cp2+1
	;
	JSR color_plink
	;
	;INC $FF19
	;
	LDA #$10
	LDX #irq1 & 255
	;
plink_irq_end
	STA $FF0B
	STX $FFFE
	;
	LDA $20
	LDX $21
	LDY $22		;save_y         
	;
	RTI           
	
plink_done
plink_2	JMP legion_start	; self-mod, after 2nd plink plasma will start
	JMP plasma_start  
	
;copy_plink2
;	LDY #32
;cpl2	LDA plink_charmap+33*6,y
;	STA plink_pos+$03C8+40*7,y
;	;
;	LDA plink_charmap+33*7,y
;	STA plink_pos+$03C8+40*8,y
;	;
;	LDA plink_charmap+33*8,y
;	STA plink_pos+$03C8+40*9,y
;	;
;	LDA plink_charmap+33*9,y
;	STA plink_pos+$03C8+40*10,y
;	;
;	LDA plink_charmap+33*10,y
;	STA plink_pos+$03C8+40*11,y
;	;
;	DEY        
;	;
;	BPL cpl2
;	;
;	RTS
	
color_plink          
	LDX #$FF
	;
	LDA #plink_pos & 255	; start position
	STA ptr_col
	LDA #plink_pos >> 8
	STA ptr_col+1
	;
	LDY #$01
	BNE cp2			; always jump
	;
cp1	LDA plink_color_data,x	; get one byte, which is the skip value
	CLC
	ADC ptr_col
	STA ptr_col
	BCC *+4
	INC ptr_col+1
	;
	INX
	;
	LDY plink_color_data,x	; next byte is number of chars to color
cp2	LDA #$41
cp3	STA (ptr_col),y
	DEY
	BPL cp3
	;
	INX
	BPL cp1			; loop ends at $80
	;
	RTS
	